/******************************************************************************/
/* WARNING: LabWindows/CVI generates this file. Do not add to, delete from,   */
/*          or otherwise modify the contents of this file.                    */
/******************************************************************************/

#ifndef _ZOUBIDA_H
#define _ZOUBIDA_H

#include <cviauto.h>

#ifdef __cplusplus
    extern "C" {
#endif


/******************************************************************************/
/* Extern Declarations of GUIDs                                               */
/******************************************************************************/

extern const GUID LIBID_Zoubida;
extern const GUID CLSID_MultObj;
extern const GUID IID_IApp;
extern const GUID IID_IScalar;


/******************************************************************************/
/* Forward Declarations of Interfaces                                         */
/******************************************************************************/

typedef interface IApp_Tag IApp;

typedef interface IScalar_Tag IScalar;


/******************************************************************************/
/* Utility functions generated by the ActiveX server wizard.                  */
/******************************************************************************/

// Initializes the server.
STDMETHODIMP CaSrvrZoubidaInit (
             	HINSTANCE hinst, char *cmdLine, int *runServer,
			 	char *errStrBuf, size_t bufSize);

// Uninitializes the server.
STDMETHODIMP CaSrvrZoubidaUninit (HINSTANCE hinst);


/******************************************************************************/
/* ActiveX server's WinMain function (sample code)                            */
/*                                                                            */
/* Note: Use WinMain instead of main as the entry-point for EXE servers.      */
/*                                                                            */
/* SIMILAR WinMain MUST BE IMPLEMENTED BY USER IN USER'S SOURCE CODE          */
/******************************************************************************/
/*

#include "Application_axs.h"
#include <cvirte.h>
#include <userint.h>

int __stdcall WinMain (HINSTANCE hInstance, HINSTANCE hPrevInstance,
                       LPSTR lpszCmdLine, int nCmdShow)
{
	int        runServer = 0;
	char       errBuf [500] = {0};

	if (InitCVIRTE (hInstance, 0, 0) == 0)
		return -1;	// Out of memory

	// ActiveX server initialization
	if (FAILED (CaSrvrZoubidaInit (
	            	hInstance, lpszCmdLine, &runServer, errBuf, sizeof(errBuf))))
		return -1;	// Server initialization error.

	if (runServer)
		{
		// ...
		// Your initialization code
		// ...

		RunUserInterface ();	// Process messages

		// ...
		// Your cleanup code
		// ...
		}

	// ActiveX server cleanup
	CaSrvrZoubidaUninit (hInstance);

	return 0;
}

*/

/******************************************************************************/
/* User's ActiveX server functions                                            */
/*                                                                            */
/* Note: These functions will be called by ActiveX clients.                   */
/*                                                                            */
/* MUST BE IMPLEMENTED BY USER IN USER'S SOURCE CODE                          */
/******************************************************************************/

HRESULT CVIFUNC MultObjIAppget_Visible (CAServerObjHandle objHandle,
                                        VARIANT_BOOL* Visible);

HRESULT CVIFUNC MultObjIAppput_Visible (CAServerObjHandle objHandle,
                                        VARIANT_BOOL Visible);

HRESULT CVIFUNC MultObjIScalarget_x (CAServerObjHandle objHandle, double* x);

HRESULT CVIFUNC MultObjIScalarput_x (CAServerObjHandle objHandle, double x);

HRESULT CVIFUNC MultObjIScalarget_y (CAServerObjHandle objHandle, double* y);

HRESULT CVIFUNC MultObjIScalarput_y (CAServerObjHandle objHandle, double y);

HRESULT CVIFUNC MultObjIScalarget_z (CAServerObjHandle objHandle, double* z);


/******************************************************************************/
/* Interface and Virtual Table Definitions                                    */
/******************************************************************************/

typedef struct IApp_Vtbl_Tag 
{
	HRESULT (STDMETHODCALLTYPE __RPC_FAR *QueryInterface) (IApp __RPC_FAR *This,
	                                                       REFIID riid,
	                                                       void __RPC_FAR *__RPC_FAR *ppvObject);
	ULONG (STDMETHODCALLTYPE __RPC_FAR *AddRef) (IApp __RPC_FAR *This);
	ULONG (STDMETHODCALLTYPE __RPC_FAR *Release) (IApp __RPC_FAR *This);
	HRESULT (STDMETHODCALLTYPE __RPC_FAR *GetTypeInfoCount) (IApp __RPC_FAR *This,
	                                                         UINT __RPC_FAR *pctInfo);
	HRESULT (STDMETHODCALLTYPE __RPC_FAR *GetTypeInfo) (IApp __RPC_FAR *This,
	                                                    UINT iTInfo, LCID lcid,
	                                                    ITypeInfo __RPC_FAR *__RPC_FAR *ppTInfo);
	HRESULT (STDMETHODCALLTYPE __RPC_FAR *GetIDsOfNames) (IApp __RPC_FAR *This,
	                                                      REFIID riid,
	                                                      LPOLESTR __RPC_FAR *rgszNames,
	                                                      UINT cNames, LCID lcid,
	                                                      DISPID __RPC_FAR *rgDispId);
	HRESULT (STDMETHODCALLTYPE __RPC_FAR *Invoke) (IApp __RPC_FAR *This,
	                                               DISPID dispIdMember,
	                                               REFIID riid, LCID lcid,
	                                               WORD wFlags,
	                                               DISPPARAMS __RPC_FAR *pDispParams,
	                                               VARIANT __RPC_FAR *pVarResult,
	                                               EXCEPINFO __RPC_FAR *pExcepInfo,
	                                               UINT __RPC_FAR *puArgErr);
	HRESULT (STDMETHODCALLTYPE __RPC_FAR *get_Visible) (IApp __RPC_FAR *This,
	                                                    /* [out,retval] */ VARIANT_BOOL __RPC_FAR * Visible);
	HRESULT (STDMETHODCALLTYPE __RPC_FAR *put_Visible) (IApp __RPC_FAR *This,
	                                                    /* [in] */ VARIANT_BOOL Visible);

} IApp_Vtbl;

typedef struct IScalar_Vtbl_Tag 
{
	HRESULT (STDMETHODCALLTYPE __RPC_FAR *QueryInterface) (IScalar __RPC_FAR *This,
	                                                       REFIID riid,
	                                                       void __RPC_FAR *__RPC_FAR *ppvObject);
	ULONG (STDMETHODCALLTYPE __RPC_FAR *AddRef) (IScalar __RPC_FAR *This);
	ULONG (STDMETHODCALLTYPE __RPC_FAR *Release) (IScalar __RPC_FAR *This);
	HRESULT (STDMETHODCALLTYPE __RPC_FAR *GetTypeInfoCount) (IScalar __RPC_FAR *This,
	                                                         UINT __RPC_FAR *pctInfo);
	HRESULT (STDMETHODCALLTYPE __RPC_FAR *GetTypeInfo) (IScalar __RPC_FAR *This,
	                                                    UINT iTInfo, LCID lcid,
	                                                    ITypeInfo __RPC_FAR *__RPC_FAR *ppTInfo);
	HRESULT (STDMETHODCALLTYPE __RPC_FAR *GetIDsOfNames) (IScalar __RPC_FAR *This,
	                                                      REFIID riid,
	                                                      LPOLESTR __RPC_FAR *rgszNames,
	                                                      UINT cNames, LCID lcid,
	                                                      DISPID __RPC_FAR *rgDispId);
	HRESULT (STDMETHODCALLTYPE __RPC_FAR *Invoke) (IScalar __RPC_FAR *This,
	                                               DISPID dispIdMember,
	                                               REFIID riid, LCID lcid,
	                                               WORD wFlags,
	                                               DISPPARAMS __RPC_FAR *pDispParams,
	                                               VARIANT __RPC_FAR *pVarResult,
	                                               EXCEPINFO __RPC_FAR *pExcepInfo,
	                                               UINT __RPC_FAR *puArgErr);
	HRESULT (STDMETHODCALLTYPE __RPC_FAR *get_x) (IScalar __RPC_FAR *This,
	                                              /* [out,retval] */ double __RPC_FAR * x);
	HRESULT (STDMETHODCALLTYPE __RPC_FAR *put_x) (IScalar __RPC_FAR *This,
	                                              /* [in] */ double x);
	HRESULT (STDMETHODCALLTYPE __RPC_FAR *get_y) (IScalar __RPC_FAR *This,
	                                              /* [out,retval] */ double __RPC_FAR * y);
	HRESULT (STDMETHODCALLTYPE __RPC_FAR *put_y) (IScalar __RPC_FAR *This,
	                                              /* [in] */ double y);
	HRESULT (STDMETHODCALLTYPE __RPC_FAR *get_z) (IScalar __RPC_FAR *This,
	                                              /* [out,retval] */ double __RPC_FAR * z);

} IScalar_Vtbl;

typedef interface IApp_Tag 
{
	CONST_VTBL IApp_Vtbl __RPC_FAR * lpVtbl;
} IApp;

typedef interface IScalar_Tag 
{
	CONST_VTBL IScalar_Vtbl __RPC_FAR * lpVtbl;
} IScalar;

#ifdef __cplusplus
    }
#endif
#endif /* _ZOUBIDA_H */
